unit ActionTestU;

interface

uses
  SysUtils, Types, Classes, Variants, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QActnList, QComCtrls, QMenus, QTypes, QImgList, QExtCtrls,
  QStdActns;

type
  TListForm = class(TForm)
    edtEntry: TEdit;
    lstEntries: TListBox;
    ActionList1: TActionList;
    ImageList1: TImageList;
    MainMenu1: TMainMenu;
    mniOptions: TMenuItem;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    actAddEntry: TAction;
    actDeleteEntry: TAction;
    actEditEntry: TAction;
    StatusBar1: TStatusBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    AddEntry1: TMenuItem;
    DeleteEntry1: TMenuItem;
    EditEntry1: TMenuItem;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    procedure actAddEntryExecute(Sender: TObject);
    procedure actAddEntryUpdate(Sender: TObject);
    procedure actDeleteEntryExecute(Sender: TObject);
    procedure actDeleteEntryUpdate(Sender: TObject);
    procedure actEditEntryExecute(Sender: TObject);
    procedure actEditEntryUpdate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ListForm: TListForm;

implementation

{$R *.xfm}

procedure TListForm.actAddEntryExecute(Sender: TObject);
begin
  lstEntries.Items.Add(TrimRight(edtEntry.Text));
  edtEntry.SetFocus;
  edtEntry.SelectAll
end;

procedure TListForm.actAddEntryUpdate(Sender: TObject);
var
  EditText: WideString;
begin
  EditText := TrimRight(edtEntry.Text);
  //Set Enabled to True if non-blank,
  //non-duplicate string is in the edit
  (Sender as TAction).Enabled :=
    (Length(EditText) > 0) and
    (lstEntries.Items.IndexOf(EditText) = -1)
end;

procedure TListForm.actDeleteEntryExecute(Sender: TObject);
begin
  lstEntries.Items.Delete(lstEntries.ItemIndex)
end;

procedure TListForm.actDeleteEntryUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := lstEntries.ItemIndex <> -1
end;

procedure TListForm.actEditEntryExecute(Sender: TObject);
begin
  if actAddEntry.Enabled then
    lstEntries.Items[lstEntries.ItemIndex] :=
      TrimRight(edtEntry.Text)
end;

procedure TListForm.actEditEntryUpdate(Sender: TObject);
begin
  //Allow this action if an item is selected in
  //the list, and the edit control has a non-blank,
  //non-duplicate value to replace that item with
  //(meaning the add action will be enabled)
  (Sender as TAction).Enabled :=
    (lstEntries.ItemIndex <> -1) and
    actAddEntry.Enabled
end;

end.
